<?php

namespace Drupal\hijri\Plugin\Block;

use Drupal\Core\Block\BlockBase;


/**
 * Provides a block to render the Hijri date.
 *
 * @Block(
 *   id = "hijri_date_block",
 *   admin_label = @Translation("Hijri Date"),
 * )
 */
class HijriDate extends BlockBase {
  /**
   * {@inheritdoc}
   */
  public function build() {
    /** @var \Drupal\hijri\HijriFormatter $hijri_formatter */
    $hijri_formatter = \Drupal::service('hijri.formatter');
    $hijri_text = $hijri_formatter->format(time());

    return [
      '#markup' => $hijri_text,
    ];
  }
}
